"IAL"

*
* Original IA Name: "68000 interface  3 stat 2421"
*
        SEARCH_LIMIT     34
        DEFAULT_WIDTH    31
        MAPPED_WIDTH     41
        ENHANCED_WIDTH   41
VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000000H
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C_UNREF  CONSTANT 000000000H
VAR_003E_UNREF  CONSTANT 000000000H
VAR_0040_UNREF  CONSTANT 000000000H
VAR_0042_UNREF  CONSTANT 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C_UNREF  CONSTANT 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052        VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A_UNREF  CONSTANT 000000000H
VAR_005C_UNREF  CONSTANT 000000000H
CONST_005E      CONSTANT 0000000FFH
VAR_0060_UNREF  CONSTANT 0000FFFFFH
CONST_0062      CONSTANT 000FFFFFFH
VAR_0064_UNREF  CONSTANT 0000000BBH
VAR_0066_UNREF  CONSTANT 00000005FH
VAR_0068_UNREF  CONSTANT 0000000BFH
VAR_006A_UNREF  CONSTANT 0000000A9H
CONST_006C      CONSTANT 0000000F0H
CONST_006E      CONSTANT 000FF0000H
CONST_0070      CONSTANT 000FF0000H
CONST_0072      CONSTANT 000FFFF00H
CONST_0074      CONSTANT 0FFFFFF00H
CONST_0076      CONSTANT 000FF0000H
CONST_0078      CONSTANT 0000000FFH
CONST_007A      CONSTANT 000FF0000H
CONST_007C      CONSTANT 0000000FFH
CONST_007E      CONSTANT 000FFFF00H
CONST_0080      CONSTANT 000000070H
STR_0000_UNREF  ASCII "supr data"
STR_0005_UNREF  ASCII "supr program"
STR_000C_UNREF  ASCII "user data"
STR_0011_UNREF  ASCII "user program"
STR_0018_UNREF  ASCII "interrupt ack"
STR_001F        ASCII "read"
STR_0022        ASCII "write"
STR_0025_UNREF  ASCII " (6800)"
STR_0029        ASCII "DMA"
STR_002B_UNREF  ASCII "incomplete opcode"
STR_0034_UNREF  ASCII "/"
STR_0035_UNREF  ASCII "-"
STR_0036        ASCII "****"
STR_0039        ASCII ","
STR_003A        ASCII "D"
STR_003B        ASCII "A"
STR_003C        ASCII "B"
STR_003D        ASCII "W"
STR_003E        ASCII "L"
STR_003F        ASCII "#"
STR_0040        ASCII "OR"
STR_0042        ASCII "AND"
STR_0044        ASCII "SUB"
STR_0046        ASCII "EOR"
STR_0048        ASCII "ADD"
STR_004A        ASCII "CLR"
STR_004C        ASCII "MOVE"
STR_004F        ASCII "SR"
STR_0051        ASCII "CCR"
STR_0053        ASCII "USP"
STR_0055        ASCII "**"
STR_0057        ASCII "S"
STR_0058        ASCII "]"
STR_0059        ASCII "R"
STR_005A        ASCII "."
STR_005B        ASCII "Illegal"
FMT_005F        FORMAT 3,BIN,3
FMT_0061        FORMAT 3,DEC,1
FMT_0063_UNREF  FORMAT 5,DEC,2
FMT_0065        FORMAT 4,HEX,1
FMT_0067        FORMAT 3,HEX,1
FMT_0069        FORMAT 8,HEX,2
FMT_006B        FORMAT 5,HEX,2
FMT_006D        FORMAT 16,HEX,4
FMT_006F_UNREF  FORMAT 20,HEX,5
FMT_0071        FORMAT 24,HEX,6
FMT_0073        FORMAT 32,HEX,8
        LABEL_TITLE      "68000 Mnemonic"
        BASE_TITLE       "      hex"

ENTRY_POINT
    SET VAR_0058,0
    CASE_OF TASK
        GOTO LABEL_0025
        GOTO LABEL_0025
        GOTO LABEL_0025
        GOTO LABEL_000C
        GOTO LABEL_0010
        GOTO LABEL_0010
    CASE_END
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Task Request"
    ABORT

LABEL_000C
    LOAD ID_CODE
    IF 7,0 = CONST_006C THEN SET VAR_0058,1

LABEL_0010
    SET RETURN_FLAGS,1
    SET VAR_004E,0
    SET VAR_0044,0
    LOAD INPUT_ADDRESS
    STORE VAR_0056
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0421
    LOAD 7
    STORE QUALIFY_MASK
    LOAD 0
    STORE QUALIFY_VALUE
    LOAD INPUT_TAG
    IF 17,16 <> 0 THEN GOTO LABEL_0040
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 = QUALIFY_VALUE THEN GOTO LABEL_0026

LABEL_0025
    SET RETURN_FLAGS,0

LABEL_0026
    POSITION ABS,3
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    POSITION REL,1
    LOAD INPUT_TAG
    IF 1,0 <> 1 THEN GOTO LABEL_0030
    OUTPUT "unused prefetch"
    RETURN

LABEL_0030
    LOAD INPUT_STATUS
    IF 2,2 = 0 THEN GOTO LABEL_0036
    OUTPUT STR_0029    * "DMA"
    RETURN

LABEL_0036
    CASE_OF 1,1
        OUTPUT "program"
        OUTPUT "data"
    CASE_END
    POSITION REL,1
    CASE_OF 0,0
        OUTPUT STR_001F    * "read"
        OUTPUT STR_0022    * "write"
    CASE_END
    RETURN

LABEL_0040
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_0025
    IF 1,0 = 1 THEN GOTO LABEL_0025
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 <> QUALIFY_VALUE THEN GOTO LABEL_0025
    LOAD INPUT_DATA
    LOAD INPUT_DATA
    CASE_OF 15,12
        GOTO LABEL_0060
        GOTO LABEL_00CD
        GOTO LABEL_00CD
        GOTO LABEL_00CD
        GOTO LABEL_00E3
        GOTO LABEL_01E0
        GOTO LABEL_0208
        GOTO LABEL_022E
        GOTO LABEL_0280
        GOTO LABEL_0239
        GOTO LABEL_02F1
        GOTO LABEL_0261
        GOTO LABEL_0280
        GOTO LABEL_0239
        GOTO LABEL_02CD
        GOTO LABEL_02F1
    CASE_END

LABEL_0060
    IF 8,8 = 1 THEN GOTO LABEL_0087
    CASE_OF 11,9
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
        GOTO LABEL_00B7
        OUTPUT STR_0046    * "EOR"
        OUTPUT "CMP"
        GOTO LABEL_0423
    CASE_END
    OUTPUT "I"
    CALL LABEL_03E9
    CALL LABEL_03AD
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 11,9
        SET VAR_004E,1
        SET VAR_004E,1
        SET VAR_004E,0
        SET VAR_004E,0
        NOP
        SET VAR_004E,1
        SET VAR_004E,0
        NOP
    CASE_END
    CALL LABEL_02F5
    IF VAR_004E = 0 THEN RETURN
    LOAD INITIAL_DATA
    IF 5,0 <> 60 THEN RETURN
    SET VAR_0054,2
    CALL LABEL_043C
    RETURN

LABEL_0087
    IF 5,3 = 1 THEN GOTO LABEL_00A0
    CALL LABEL_008F
    POSITION ABS,9
    CALL LABEL_042C
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F5

LABEL_008F
    OUTPUT STR_003C    * "B"
    CASE_OF 7,6
        OUTPUT "TST"
        OUTPUT "CHG"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "SET"
    CASE_END
    OUTPUT STR_005A    * "."
    IF 5,3 = 0 THEN GOTO LABEL_009D
    OUTPUT STR_003C    * "B"
    SET VAR_003A,0
    RETURN

LABEL_009D
    OUTPUT STR_003E    * "L"
    SET VAR_003A,2
    RETURN

LABEL_00A0
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "P."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 6,6
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    SET VAR_0038,5
    POSITION ABS,9
    CASE_OF 7,7
        CALL LABEL_0304
        CALL LABEL_042C
    CASE_END
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 7,7
        CALL LABEL_042C
        CALL LABEL_0304
    CASE_END
    RETURN

LABEL_00B7
    CALL LABEL_008F
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_03CE
    IF INPUT_ERROR = 0 THEN GOTO LABEL_00C4
    LOAD VAR_003A
    CASE_OF 1,1
        OUTPUT "*"
        OUTPUT STR_0055    * "**"
    CASE_END
    GOTO LABEL_00CB

LABEL_00C4
    LOAD INPUT_DATA
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0067    * 3,HEX,1
        NOP
        OUTPUT ACCUMULATOR,FMT_006B    * 5,HEX,2
        NOP
    CASE_END

LABEL_00CB
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F5

LABEL_00CD
    OUTPUT STR_004C    * "MOVE"
    IF 8,6 = 1 THEN OUTPUT STR_003B    * "A"
    OUTPUT STR_005A    * "."
    CASE_OF 13,12
        NOP
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003E    * "L"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 13,12
        NOP
        SET VAR_003A,0
        SET VAR_003A,2
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CALL LABEL_02F5
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_02F7

LABEL_00E3
    IF 8,7 = 2 THEN GOTO LABEL_0423
    IF 8,8 = 1 THEN GOTO LABEL_0109
    IF 11,11 = 0 THEN GOTO LABEL_0116
    CASE_OF 10,9
        GOTO LABEL_00F3
        GOTO LABEL_0181
        GOTO LABEL_018A
        GOTO LABEL_018E
    CASE_END
    RETURN

LABEL_00F3
    CASE_OF 7,6
        OUTPUT "NBCD.B"
        GOTO LABEL_00FB
        GOTO LABEL_0156
        GOTO LABEL_0156
    CASE_END
    POSITION ABS,9
    GOTO LABEL_02F5

LABEL_00FB
    SET VAR_0050,0
    IF 5,3 <> 0 THEN SET VAR_0050,1
    CASE_OF VAR_0050
        OUTPUT "SWAP.W"
        OUTPUT "PEA.L"
    CASE_END
    POSITION ABS,9
    CASE_OF VAR_0050
        CALL LABEL_042E
        CALL LABEL_02F5
    CASE_END
    RETURN

LABEL_0109
    CASE_OF 6,6
        OUTPUT "CHK.W"
        OUTPUT "LEA.L"
    CASE_END
    POSITION ABS,9
    CALL LABEL_02F5
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 6,6
        CALL LABEL_042C
        CALL LABEL_0428
    CASE_END
    RETURN

LABEL_0116
    IF 7,6 = 3 THEN GOTO LABEL_0122
    CASE_OF 10,9
        OUTPUT "NEGX"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "NEG"
        OUTPUT "NOT"
    CASE_END
    CALL LABEL_03E9
    CALL LABEL_02F5
    RETURN

LABEL_0122
    OUTPUT STR_004C    * "MOVE"
    OUTPUT STR_005A    * "."
    CASE_OF 10,9
        OUTPUT STR_003D    * "W"
        GOTO LABEL_0423
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 10,9
        SET VAR_003A,1
        SET VAR_003A,1
        SET VAR_003A,0
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CASE_OF 10,9
        OUTPUT STR_004F    * "SR"
        OUTPUT STR_0051    * "CCR"
        CALL LABEL_02F5
        CALL LABEL_02F5
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,9
        CALL LABEL_02F5
        CALL LABEL_02F5
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
    CASE_END
    LOAD INITIAL_DATA
    IF 10,9 < 2 THEN RETURN
    CASE_OF 5,3
        SET VAR_0054,1
        NOP
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,2
        SET VAR_0054,2
        CALL LABEL_014E
    CASE_END
    GOTO LABEL_043C

LABEL_014E
    CASE_OF 2,0
        SET VAR_0054,2
        SET VAR_0054,3
        SET VAR_0054,2
        SET VAR_0054,2
        SET VAR_0054,2
    CASE_END
    RETURN

LABEL_0156
    IF 5,3 = 0 THEN GOTO LABEL_017A

LABEL_0159
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "M."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_03CE
    STORE VAR_0052
    IF INPUT_ERROR <> 0 THEN SET VAR_0052,0
    POSITION ABS,9
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_0171
        CALL LABEL_02F5
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_02F5
        CALL LABEL_0171
    CASE_END
    RETURN

LABEL_0171
    OUTPUT "rm="
    LOAD VAR_0052
    IF 15,0 <> 0 THEN GOTO LABEL_0178
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_0178
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_017A
    OUTPUT "EXT."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_042E

LABEL_0181
    IF 7,6 <> 3 THEN GOTO LABEL_0186
    OUTPUT "TAS.B"
    GOTO LABEL_0188

LABEL_0186
    OUTPUT "TST"
    CALL LABEL_03E9

LABEL_0188
    POSITION ABS,9
    GOTO LABEL_02F5

LABEL_018A
    IF 7,7 = 0 THEN GOTO LABEL_0423
    GOTO LABEL_0159

LABEL_018E
    CASE_OF 8,6
        GOTO LABEL_0423
        GOTO LABEL_0196
        OUTPUT "JSR"
        OUTPUT "JMP"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_02F5

LABEL_0196
    CASE_OF 5,4
        GOTO LABEL_01BC
        GOTO LABEL_01C3
        GOTO LABEL_01D3
        NOP
    CASE_END
    IF 5,3 = 7 THEN GOTO LABEL_0423
    CASE_OF 2,0
        OUTPUT "RESET"
        OUTPUT "NOP"
        OUTPUT "STOP"
        OUTPUT "RTE"
        GOTO LABEL_0423
        OUTPUT "RTS"
        OUTPUT "TRAPV"
        OUTPUT "RTR"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_01B4
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_03CE
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0426
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_01B4
    IF 2,0 < 3 THEN RETURN
    IF 2,0 = 6 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_043C

LABEL_01BC
    OUTPUT "TRAP"
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    AND 15
    OUTPUT ACCUMULATOR,FMT_0065    * 4,HEX,1
    SET VAR_0054,1
    GOTO LABEL_043C

LABEL_01C3
    CASE_OF 3,3
        OUTPUT "LINK"
        OUTPUT "UNLK"
    CASE_END
    POSITION ABS,9
    CALL LABEL_042A
    IF 3,3 = 1 THEN RETURN
    OUTPUT ",#"
    CALL LABEL_03CE
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0426
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_01D3
    OUTPUT STR_004C    * "MOVE"
    OUTPUT ".L"
    POSITION ABS,9
    CASE_OF 3,3
        CALL LABEL_042A
        OUTPUT STR_0053    * "USP"
    CASE_END
    OUTPUT STR_0039    * ","
    CASE_OF 3,3
        OUTPUT STR_0053    * "USP"
        CALL LABEL_042A
    CASE_END
    RETURN

LABEL_01E0
    IF 7,6 <> 3 THEN GOTO LABEL_0200
    IF 5,3 = 1 THEN GOTO LABEL_01E8
    OUTPUT STR_0057    * "S"
    GOTO LABEL_01E9

LABEL_01E8
    OUTPUT "DB"

LABEL_01E9
    CALL LABEL_0400
    IF 5,3 = 1 THEN GOTO LABEL_01F0
    OUTPUT ".B"
    POSITION ABS,9
    GOTO LABEL_02F5

LABEL_01F0
    POSITION ABS,9
    OUTPUT STR_003A    * "D"
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CALL LABEL_03CE
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0426
    IF 15,15 = 1 THEN INCLUSIVE_OR CONST_006E
    ADD INPUT_ADDRESS

LABEL_01FC
    AND CONST_0062
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0071    * 24,HEX,6
    RETURN

LABEL_0200
    CASE_OF 8,8
        OUTPUT "ADDQ"
        OUTPUT "SUBQ"
    CASE_END
    CALL LABEL_03E9
    CALL LABEL_03F6
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F5

LABEL_0208
    OUTPUT STR_003C    * "B"
    CALL LABEL_0400
    IF 7,0 <> 0 THEN GOTO LABEL_0218
    OUTPUT ".W"
    SET VAR_003A,1
    CALL LABEL_03CE
    IF 15,15 = 1 THEN INCLUSIVE_OR CONST_0070
    IF INPUT_ERROR = 0 THEN GOTO LABEL_021E
    OUTPUT "********"
    RETURN

LABEL_0218
    OUTPUT ".B"
    SET VAR_003A,0
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR CONST_0072

LABEL_021E
    POSITION ABS,9
    ADD INPUT_ADDRESS
    AND CONST_0062
    IF VAR_003A = 0 THEN ADD 2
    CALL LABEL_01FC
    LOAD INITIAL_DATA
    IF 15,9 <> 48 THEN RETURN
    IF 7,0 = 0 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_043C

LABEL_022E
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "Q.L"
    POSITION ABS,9
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR CONST_0074
    OUTPUT STR_003F    * "#"
    OUTPUT ACCUMULATOR,FMT_0073    * 32,HEX,8
    OUTPUT STR_0039    * ","
    GOTO LABEL_042C

LABEL_0239
    CASE_OF 14,14
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
    CASE_END
    IF 7,6 = 3 THEN GOTO LABEL_0253
    IF 8,8 <> 1 THEN GOTO LABEL_0246
    IF 5,4 = 0 THEN GOTO LABEL_0432

LABEL_0246
    CALL LABEL_03E9
    POSITION ABS,9
    CASE_OF 8,8
        CALL LABEL_02F5
        CALL LABEL_042C
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 8,8
        CALL LABEL_042C
        CALL LABEL_02F5
    CASE_END
    RETURN

LABEL_0253
    OUTPUT "A."

LABEL_0254
    CASE_OF 8,8
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 8,8
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    POSITION ABS,9
    CALL LABEL_02F5
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_0428

LABEL_0261
    IF 7,6 = 3 THEN GOTO LABEL_026C
    IF 8,8 = 1 THEN GOTO LABEL_026E
    OUTPUT "CMP"
    CALL LABEL_03E9
    CALL LABEL_02F5
    OUTPUT STR_0039    * ","
    GOTO LABEL_042C

LABEL_026C
    OUTPUT "CMPA."
    GOTO LABEL_0254

LABEL_026E
    IF 5,3 <> 1 THEN GOTO LABEL_027B
    OUTPUT "CMPM"
    CALL LABEL_03E9
    POSITION ABS,9
    OUTPUT "[xx]+,[xx]+"
    POSITION REL,-10
    CALL LABEL_042A
    POSITION REL,4
    CALL LABEL_0428
    POSITION REL,2
    RETURN

LABEL_027B
    OUTPUT STR_0046    * "EOR"
    CALL LABEL_03E9
    CALL LABEL_042C
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F5

LABEL_0280
    IF 7,6 = 3 THEN GOTO LABEL_0294
    IF 14,14 = 0 THEN GOTO LABEL_028C
    IF 8,4 = 20 THEN GOTO LABEL_02B3
    IF 8,4 = 24 THEN GOTO LABEL_02B3

LABEL_028C
    IF 8,4 = 16 THEN GOTO LABEL_02A1
    CASE_OF 14,14
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
    CASE_END
    GOTO LABEL_0246

LABEL_0294
    CASE_OF 14,14
        OUTPUT "DIV"
        OUTPUT "MUL"
    CASE_END
    CASE_OF 8,8
        OUTPUT "U"
        OUTPUT STR_0057    * "S"
    CASE_END
    OUTPUT ".W"
    POSITION ABS,9
    CALL LABEL_02F5
    OUTPUT STR_0039    * ","
    GOTO LABEL_042C

LABEL_02A1
    CASE_OF 14,14
        OUTPUT STR_0057    * "S"
        OUTPUT STR_003B    * "A"
    CASE_END
    OUTPUT "BCD.B"
    POSITION ABS,9
    IF 3,3 = 0 THEN GOTO LABEL_02B0
    OUTPUT "-["
    CALL LABEL_042A
    OUTPUT "],-["
    CALL LABEL_0428
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_02B0
    CALL LABEL_042E
    OUTPUT STR_0039    * ","
    GOTO LABEL_042C

LABEL_02B3
    OUTPUT "EXG.L"
    POSITION ABS,9
    IF 7,3 = 8 THEN SET VAR_0050,0
    IF 7,3 = 9 THEN SET VAR_0050,1
    IF 7,3 = 17 THEN SET VAR_0050,2
    CASE_OF VAR_0050
        CALL LABEL_042C
        CALL LABEL_0428
        CALL LABEL_042C
        NOP
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF VAR_0050
        CALL LABEL_042E
        CALL LABEL_042A
        CALL LABEL_042A
        NOP
    CASE_END
    RETURN

LABEL_02CD
    IF 7,6 = 3 THEN GOTO LABEL_02E3
    CASE_OF 4,3
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_03E9
    IF 5,5 = 1 THEN GOTO LABEL_02E0
    CALL LABEL_03F6
    GOTO LABEL_02E1

LABEL_02E0
    CALL LABEL_042C

LABEL_02E1
    OUTPUT STR_0039    * ","
    GOTO LABEL_042E

LABEL_02E3
    CASE_OF 10,9
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT ".W"
    SET VAR_003A,1
    POSITION ABS,9
    GOTO LABEL_02F5

LABEL_02F1
    OUTPUT "Unimplemented Instruction:"
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    SET VAR_0054,1
    GOTO LABEL_043C

LABEL_02F5
    SET VAR_0034,1
    GOTO LABEL_02F8

LABEL_02F7
    SET VAR_0034,0

LABEL_02F8
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,6
        ROTATE RIGHT,3
    CASE_END
    AND 7
    STORE VAR_0038
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,9
        NOP
    CASE_END

LABEL_0304
    AND 7
    STORE VAR_0036
    CASE_OF VAR_0038
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
        OUTPUT "[A"
        OUTPUT "[A"
        OUTPUT "-[A"
        GOTO LABEL_031E
        GOTO LABEL_0325
        GOTO LABEL_0346
    CASE_END
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    CASE_OF VAR_0038
        RETURN
        RETURN
        OUTPUT STR_0058    * "]"
        OUTPUT "]+"
        OUTPUT STR_0058    * "]"
        NOP
        NOP
        NOP
    CASE_END
    RETURN

LABEL_031E
    CALL LABEL_03C8
    OUTPUT "[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_0325
    CALL LABEL_03CE
    IF INPUT_ERROR = 0 THEN GOTO LABEL_032E
    OUTPUT "**[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT ",**.*]"
    RETURN

LABEL_032E
    AND CONST_005E
    OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
    OUTPUT "["
    LOAD INPUT_DATA
    OUTPUT STR_003B    * "A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    LOAD INPUT_DATA
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_0346
    CASE_OF VAR_0036
        GOTO LABEL_034E
        GOTO LABEL_0358
        GOTO LABEL_037C
        GOTO LABEL_0387
        GOTO LABEL_03A3
    CASE_END
    GOTO LABEL_041D

LABEL_034E
    CALL LABEL_03CE
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0354
    OUTPUT "******"
    RETURN

LABEL_0354
    IF 15,15 = 1 THEN INCLUSIVE_OR CONST_0076
    GOTO LABEL_01FC

LABEL_0358
    CALL LABEL_03CE
    STORE VAR_0048
    SET VAR_0046,0
    IF INPUT_ERROR <> 0 THEN SET VAR_0046,1
    CALL LABEL_03CE
    STORE VAR_004A
    LOAD VAR_0046
    IF INPUT_ERROR <> 0 THEN INCLUSIVE_OR 2
    STORE VAR_0046
    IF VAR_0046 = 0 THEN GOTO LABEL_0377
    LOAD VAR_0048
    CASE_OF VAR_0046
        NOP
        OUTPUT STR_0036    * "****"
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
    CASE_END
    LOAD VAR_004A
    CASE_OF VAR_0046
        NOP
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
    CASE_END
    RETURN

LABEL_0377
    LOAD VAR_0048
    AND CONST_0078
    ROTATE LEFT,16
    INCLUSIVE_OR VAR_004A
    GOTO LABEL_01FC

LABEL_037C
    CALL LABEL_03CE
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0426
    IF 15,15 = 1 THEN INCLUSIVE_OR CONST_007A
    ADD INPUT_ADDRESS
    CALL LABEL_01FC
    OUTPUT "[PC]"
    RETURN

LABEL_0387
    CALL LABEL_03CE
    IF INPUT_ERROR = 0 THEN GOTO LABEL_038D
    OUTPUT "**[PC,**.*]"
    RETURN

LABEL_038D
    AND CONST_007C
    IF 7,7 = 1 THEN INCLUSIVE_OR CONST_007E
    ADD INPUT_ADDRESS
    CALL LABEL_01FC
    LOAD INPUT_DATA
    OUTPUT "[PC,"
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_03A3
    IF VAR_004E = 0 THEN GOTO LABEL_03AD
    CASE_OF VAR_003A
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
        GOTO LABEL_041D
        GOTO LABEL_041D
    CASE_END
    RETURN

LABEL_03AD
    OUTPUT STR_003F    * "#"
    CALL LABEL_03CE
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03B9
    CASE_OF VAR_003A
        OUTPUT STR_0055    * "**"
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
        GOTO LABEL_0423
    CASE_END
    GOTO LABEL_03BF

LABEL_03B9
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        GOTO LABEL_0423
    CASE_END

LABEL_03BF
    IF VAR_003A <> 2 THEN RETURN
    CALL LABEL_03CE
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0426
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_03C8
    CALL LABEL_03CE
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0426
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_03CE
    INCREMENT VAR_0056
    INCREMENT VAR_0056
    CALL LABEL_03D7
    CALL LABEL_03D9
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    LOAD INPUT_DATA
    RETURN

LABEL_03D7
    INPUT ABS,VAR_0056,QUALIFIED
    RETURN

LABEL_03D9
    IF TASK = 3 THEN RETURN
    IF VAR_0044 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    SET VAR_0044,1
    SET INPUT_ERROR,1
    RETURN

LABEL_03E9
    OUTPUT STR_005A    * "."
    CASE_OF 7,6
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
        GOTO LABEL_041D
    CASE_END
    ROTATE RIGHT,6
    AND 3
    STORE VAR_003A
    LOAD INITIAL_DATA
    POSITION ABS,9
    RETURN

LABEL_03F6
    OUTPUT STR_003F    * "#"
    IF 11,9 <> 0 THEN GOTO LABEL_03FC
    OUTPUT "8"
    RETURN

LABEL_03FC
    ROTATE RIGHT,9
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_0400
    CASE_OF 11,8
        GOTO LABEL_0413
        GOTO LABEL_0418
        OUTPUT "HI"
        OUTPUT "LS"
        OUTPUT "CC"
        OUTPUT "CS"
        OUTPUT "NE"
        OUTPUT "EQ"
        OUTPUT "VC"
        OUTPUT "VS"
        OUTPUT "PL"
        OUTPUT "MI"
        OUTPUT "GE"
        OUTPUT "LT"
        OUTPUT "GT"
        OUTPUT "LE"
    CASE_END
    RETURN

LABEL_0413
    CASE_OF 12,12
        OUTPUT "RA"
        OUTPUT "T"
    CASE_END
    RETURN

LABEL_0418
    CASE_OF 12,12
        OUTPUT STR_004F    * "SR"
        OUTPUT "F"
    CASE_END
    RETURN

LABEL_041D
    POSITION ABS,9
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Operand    "
    ABORT

LABEL_0421
    OUTPUT "Data Error"
    ABORT

LABEL_0423
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Opcode"
    ABORT

LABEL_0426
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_0428
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_042A
    OUTPUT STR_003B    * "A"
    GOTO LABEL_042F

LABEL_042C
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_042E
    OUTPUT STR_003A    * "D"

LABEL_042F
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_0432
    OUTPUT "X"
    CALL LABEL_03E9
    CASE_OF 3,3
        SET VAR_0038,0
        SET VAR_0038,4
    CASE_END
    CALL LABEL_0304
    ROTATE RIGHT,9
    OUTPUT STR_0039    * ","
    GOTO LABEL_0304

LABEL_043C
    INPUT REL,VAR_0054,QUALIFIED
    CALL LABEL_03D9
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD VAR_0056
    ADD 2
    SUBTRACT INPUT_ADDRESS
    IF 31,0 <> 0 THEN RETURN
    TAG_WITH 1
    RETURN
    OUTPUT "unknown ("
    AND CONST_0080
    ROTATE RIGHT,4
    OUTPUT ACCUMULATOR,FMT_005F    * 3,BIN,3
    OUTPUT ")"
    LOAD INPUT_STATUS
    RETURN
